"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const workerQueue_1 = require("./task/workerQueue");
function displayReportAndExit(reporters, context) {
    if (workerQueue_1.workerQueue) {
        workerQueue_1.workerQueue.close();
    }
    context.measures.duration = process.hrtime(context.measures.start);
    for (const reporter of reporters) {
        reporter.summarize(context);
    }
    if (context.measures.failedTasks && context.measures.failedTasks.length > 0) {
        process.exit(1);
    }
}
exports.displayReportAndExit = displayReportAndExit;
